export declare const builtInFunctions: {
    min: (...args: number[]) => number;
    max: (...args: number[]) => number;
    abs: (value: number) => number;
    ceil: (value: number) => number;
    floor: (value: number) => number;
    round: (value: number) => number;
    contains: (str: string, substr: string) => boolean;
    endsWith: (str: string, substr: string) => boolean;
    indexOf: (str: string, substr: string) => number;
    length: (str: string) => number;
    lower: (str: string) => string;
    replace: (str: string, substr: string, newSubstr: string) => string;
    split: (str: string, separator: string) => string[];
    startsWith: (str: string, substr: string) => boolean;
    upper: (str: string) => string;
    size: (value: any) => number;
    int: (value: any) => number;
    uint: (value: any) => number;
    double: (value: any) => number;
    string: (value: any) => string;
    bool: (value: any) => boolean;
    exists: (value: any) => boolean;
    existsOne: (list: any[]) => boolean;
    matches: (value: string, regex: string) => boolean;
    timestamp: (value: string) => Date;
    type: (value: any) => "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function" | "null" | "bool" | "int" | "float" | "list";
    duration: (seconds: number) => string;
    time: (year: number, month: number, day: number, hour: number, minute: number, second: number, millisecond: number) => string;
    date: (year: number, month: number, day: number) => string;
    getFullYear: (date: Date) => number;
    getMonth: (date: Date) => number;
    getDate: (date: Date) => number;
    getHours: (date: Date) => number;
    getMinutes: (date: Date) => number;
    getSeconds: (date: Date) => number;
    compareDates: (date1: Date, date2: Date) => number;
};
