export default class Context {
    constructor(variables = {}, types = {}) {
        this.variables = variables;
        this.types = types;
    }
    getVariable(name) {
        const parts = name.split('.');
        let current = this.variables;
        for (const part of parts) {
            if (current && typeof current === 'object' && part in current) {
                current = current[part];
            }
            else {
                return undefined;
            }
        }
        return current;
    }
    getType(name) {
        const parts = name.split('.');
        let current = this.types;
        for (const part of parts) {
            if (current && typeof current === 'object' && part in current) {
                current = current[part];
            }
            else {
                return undefined;
            }
        }
        return current;
    }
    setVariable(name, value) {
        this.variables[name] = value;
    }
    setType(name, type) {
        this.types[name] = type;
    }
}
