import CELVisitor from './generated/CELVisitor';
import Context from './Context';
/**
 * Validates if a string represents a valid timestamp in ISO 8601 format.
 * Accepts both date-only (YYYY-MM-DD) and full datetime formats.
 */
export declare function isValidTimestampString(str: string): boolean;
export declare class Evaluator extends CELVisitor<any> {
    private context;
    constructor(context?: Context);
    setContext(context: Context): void;
    visitStart: (ctx: any) => any;
    visitExpr: (ctx: any) => any;
    visitConditionalOr: (ctx: any) => any;
    visitConditionalAnd: (ctx: any) => any;
    visitRelationOp: (ctx: any) => boolean;
    private evaluateComparison;
    visitRelationCalc: (ctx: any) => any;
    visitCalcAddSub: (ctx: any) => any;
    visitCalcMulDiv: (ctx: any) => any;
    visitCalcUnary: (ctx: any) => any;
    visitLogicalNot: (ctx: any) => boolean;
    visitNegate: (ctx: any) => number;
    visitMemberExpr: (ctx: any) => any;
    visitSelectOrCall: (ctx: any) => any;
    visitPrimaryExpr: (ctx: any) => any;
    visitIdentOrGlobalCall: (ctx: any) => any;
    visitNested: (ctx: any) => any;
    visitExprList: (ctx: any) => any[];
    visitConstantLiteral: (ctx: any) => any;
    visitInt: (ctx: any) => number;
    visitUint: (ctx: any) => number;
    visitDouble: (ctx: any) => number;
    visitString: (ctx: any) => any;
    visitBoolTrue: (ctx: any) => boolean;
    visitBoolFalse: (ctx: any) => boolean;
    visitNull: (ctx: any) => null;
    visitIdent: (ctx: any) => {
        [key: string]: any;
    };
    visitConditionalExpr: (ctx: any) => any;
}
export default Evaluator;
